/****************************************************************************************** 
 *	Chili DirectX Framework Version 12.04.24											  *	
 *	Game.h																				  *
 *	Copyright 2012 PlanetChili.net														  *
 *																						  *
 *	This file is part of The Chili DirectX Framework.									  *
 *																						  *
 *	The Chili DirectX Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili DirectX Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of						  *
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili DirectX Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#pragma once

#include "D3DGraphics.h"
#include "Keyboard.h"
#include "Mouse.h"
#include "Sound.h"

class Game
{
	struct FighterLookingUp
	{
		int x;
		int y;
	};
	struct FighterLookingLeft
	{
		int x;
		int y;
	};
	struct FighterLookingDown
	{
		int x;
		int y;
	};
	struct FighterLookingRight
	{
		int x;
		int y;
	};

	struct BlueEnemyLookingUp
	{
		int x;
		int y;
	};
	struct BlueEnemyLookingLeft
	{
		int x;
		int y;
	};
	struct BlueEnemyLookingDown
	{
		int x;
		int y;
	};
	struct BlueEnemyLookingRight
	{
		int x;
		int y;
	};
	struct BlueRedWhiteEnemyLookingUp
	{
		int x;
		int y;
	};
	struct BlueRedWhiteEnemyLookingLeft
	{
		int x;
		int y;
	};
	struct BlueRedWhiteEnemyLookingDown
	{
		int x;
		int y;
	};
	struct BlueRedWhiteEnemyLookingRight
	{
		int x;
		int y;
	};
	struct BlueRedWhiteBigEnemyUp
	{
		int x;
		int y;
	};
	struct BlueRedWhiteBigEnemyLeft
	{
		int x;
		int y;
	};
	struct BlueRedWhiteBigEnemyRight
	{
		int x;
		int y;
	};
	struct BlueRedWhiteBigEnemyDown
	{
		int x;
		int y;
	};
	struct BlueYellowEnemyUp
	{
		int x;
		int y;
	};
	struct BlueYellowEnemyDown
	{
		int x;
		int y;
	};
	struct BlueYellowEnemyLeft
	{
		int x;
		int y;
	};
	struct BlueYellowEnemyRight
	{
		int x;
		int y;
	};
	struct BlueYellowRedEnemyUp
	{
		int x;
		int y;
	};
	struct BlueYellowRedEnemyDown
	{
		int x;
		int y;
	};
	struct BlueYellowRedEnemyLeft
	{
		int x;
		int y;
	};
	struct BlueYellowRedEnemyRight
	{
		int x;
		int y;
	};
	struct BossEnemyUp
	{
		int x;
		int y;
	};
	struct BossEnemyDown
	{
		int x;
		int y;
	};
	struct BossEnemyLeft
	{
		int x;
		int y;
	};
	struct BossEnemyRight
	{
		int x;
		int y;
	};
	struct HitOnceBossEnemyUp
	{
		int x;
		int y;
	};
	struct HitOnceBossEnemyDown
	{
		int x;
		int y;
	};
	struct HitOnceBossEnemyLeft
	{
		int x;
		int y;
	};
	struct HitOnceBossEnemyRight
	{
		int x;
		int y;
	};

	struct EnemyDie
	{
		int x;
		int y;
	};

	struct FighterMissileUp
	{
		int x;
		int y;
	};
	struct FighterMissileDown
	{
		int x;
		int y;
	};
	struct FighterMissileLeft
	{
		int x;
		int y;
	};
	struct FighterMissileRight
	{
		int x;
		int y;
	};
	struct EnemyMissileUp
	{
		int x;
		int y;
	};
	struct EnemyMissileDown
	{
		int x;
		int y;
	};
	struct EnemyMissileLeft
	{
		int x;
		int y;
	};
	struct EnemyMissileRight
	{
		int x;
		int y;
	};

	struct FighterDie
	{
		int x;
		int y;
	};

	struct GreenPurpleEnemyUp
	{
		int x;
		int y;
	};
	struct GreenPurpleEnemyDown
	{
		int x;
		int y;
	};
	struct GreenPurpleEnemyLeft
	{
		int x;
		int y;
	};
	struct GreenPurpleEnemyRight
	{
		int x;
		int y;
	};
	struct RedEnemyUp
	{
		int x;
		int y;
	};
	struct RedEnemyDown
	{
		int x;
		int y;
	};
	struct RedEnemyLeft
	{
		int x;
		int y;
	};
	struct RedEnemyRight
	{
		int x;
		int y;
	};
	struct Stage
	{
		int x;
		int y;
	};

	struct Stage5
	{
		int x;
		int y;
	};

	struct Stage10
	{
		int x;
		int y;
	};
	
public:
	Game( HWND hWnd,const KeyboardServer& kServer,const MouseServer& mServer );
	void Go();
private:
	void ComposeFrame();
	/********************************/
	/*  User Functions              */


	/*  The words mean facing which direction and at which angle   */
	void DrawBlueEnemyLookingDown( int x, int y );
	void DrawBlueEnemyLookingLeft( int x, int y );
	void DrawBlueEnemyLookingRight( int x, int y );
	void DrawBlueEnemyLookingUp( int x, int y );
	void DrawBlueEnemyWingsClosedLookingDown( int x, int y );
	void DrawBlueEnemyWingsClosedLookingLeft( int x, int y );
	void DrawBlueEnemyWingsClosedLookingRight( int x, int y );
	void DrawBlueEnemyWingsClosedLookingUp( int x, int y );
	void DrawBlueRedWhiteBigEnemyDown( int x, int y );
	void DrawBlueRedWhiteBigEnemyLeft( int x, int y );
	void DrawBlueRedWhiteBigEnemyRight( int x, int y );
	void DrawBlueRedWhiteBigEnemyUp( int x, int y );
	void DrawBlueRedWhiteEnemyDown( int x, int y );
	void DrawBlueRedWhiteEnemyLeft( int x, int y );
	void DrawBlueRedWhiteEnemyRight( int x, int y );
	void DrawBlueRedWhiteEnemyUp( int x, int y );
	void DrawBlueYellowEnemyDown( int x, int y );
	void DrawBlueYellowEnemyLeft( int x, int y );
	void DrawBlueYellowEnemyRight( int x, int y );
	void DrawBlueYellowEnemyUp( int x, int y );
	void DrawBlueYellowRedEnemyDown( int x, int y );
	void DrawBlueYellowRedEnemyLeft( int x, int y );
	void DrawBlueYellowRedEnemyRight( int x, int y );
	void DrawBlueYellowRedEnemyUp( int x, int y );
	void DrawEnemyBossHitOnceLookingDown( int x, int y );
	void DrawEnemyBossHitOnceLookingLeft( int x, int y );
	void DrawEnemyBossHitOnceLookingRight( int x, int y );
	void DrawEnemyBossHitOnceLookingUp( int x, int y );
	void DrawEnemyBossLookingDown( int x, int y );
	void DrawEnemyBossLookingLeft( int x, int y );
	void DrawEnemyBossLookingRight( int x, int y );
	void DrawEnemyBossLookingUp( int x, int y );
	void DrawEnemyDieStage1( int x, int y );
	void DrawEnemyDieStage2( int x, int y );
	void DrawEnemyDieStage3( int x, int y );
	void DrawEnemyDieStage4( int x, int y );
	void DrawEnemyDieStage5( int x, int y );
	void DrawEnemyMissileLookingDown( int x, int y );
	void DrawEnemyMissileLookingLeft( int x, int y );
	void DrawEnemyMissileLookingRight( int x, int y );
	void DrawEnemyMissileLookingUp( int x, int y );
	void DrawFighterDieStage1( int x, int y );
	void DrawFighterDieStage2( int x, int y );
	void DrawFighterDieStage3( int x, int y );
	void DrawFighterDieStage4( int x, int y );
	void DrawFighterLookingDown( int x, int y );
	void DrawFighterLookingLeft( int x, int y );
	void DrawFighterLookingRight( int x, int y );
	void DrawFighterLookingUp( int x, int y );
	void DrawFighterMissileLookingDown( int x, int y );
	void DrawFighterMissileLookingLeft( int x, int y );
	void DrawFighterMissileLookingRight( int x, int y );
	void DrawFighterMissileLookingUp( int x, int y );
	void DrawGreenPurpleEnemyDown( int x, int y );
	void DrawGreenPurpleEnemyLeft( int x, int y );
	void DrawGreenPurpleEnemyRight( int x, int y );
	void DrawGreenPurpleEnemyUp( int x, int y );
	void DrawRedEnemyLookingDown( int x, int y );
	void DrawRedEnemyLookingLeft( int x, int y );
	void DrawRedEnemyLookingRight( int x, int y );
	void DrawRedEnemyLookingUp( int x, int y );
	void DrawRedEnemyWingsClosedLookingDown( int x, int y );
	void DrawRedEnemyWingsClosedLookingLeft( int x, int y );
	void DrawRedEnemyWingsClosedLookingRight( int x, int y );
	void DrawRedEnemyWingsClosedLookingUp( int x, int y );
	void DrawStage( int x, int y );
	void DrawStage5( int x, int y );
	void DrawStage10( int x, int y );



	void UpdateGame();

	void Border();




	/********************************/
private:
	D3DGraphics gfx;
	KeyboardClient kbd;
	MouseClient mouse;
	DSound audio;
	/********************************/
	/*  User Variables              */

	


	/********************************/
};