/****************************************************************************************** 
 *	Chili Directx Framework Version 12.04.24											  *	
 *	Game.cpp																			  *
 *	Copyright 2012 PlanetChili.net														  *
 *																						  *
 *	This file is part of The Chili Directx Framework.									  *
 *																						  *
 *	The Chili Directx Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili Directx Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANy WARRANTy; without even the implied warranty of						  *
 *	MERCHANTABILITy or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili Directx Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#include "Game.h"

Game::Game( HWND hWnd,const KeyboardServer& kServer,const MouseServer& mServer )
:	gfx( hWnd ),
	audio( hWnd ),
	kbd( kServer ),
	mouse( mServer )
{}

void Game::Go()
{
	gfx.BeginFrame();
	ComposeFrame();
	gfx.EndFrame();
}

void Game::DrawBlueEnemyLookingDown( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(11 + x, 9 + y, 0, 104, 222);

}
void Game::DrawBlueEnemyLookingLeft( int x, int y )
{
	gfx.PutPixel(7 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 12 + y, 0, 104, 222);

}
void Game::DrawBlueEnemyLookingRight( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 12 + y, 0, 104, 222);

}
void Game::DrawBlueEnemyLookingUp( int x, int y )
{
	gfx.PutPixel(1 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 0 + y, 255, 255, 0);
	gfx.PutPixel(11 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 1 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 1 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 1 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 9 + y, 0, 104, 222);

}
void Game::DrawBlueEnemyWingsClosedLookingDown( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 9 + y, 0, 104, 222);

}
void Game::DrawBlueEnemyWingsClosedLookingLeft( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 8 + y, 0, 104, 222);

}
void Game::DrawBlueEnemyWingsClosedLookingRight( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(0 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 8 + y, 0, 104, 222);

}
void Game::DrawBlueEnemyWingsClosedLookingUp( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 0 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 1 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 1 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 1 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 9 + y, 0, 104, 222);

}
void Game::DrawBlueRedWhiteBigEnemyDown( int x, int y )
{
	gfx.PutPixel(5 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 15 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 15 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 15 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 15 + y, 0, 104, 222);

}
void Game::DrawBlueRedWhiteBigEnemyLeft( int x, int y )
{
	gfx.PutPixel(6 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(15 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 12 + y, 0, 104, 222);

}
void Game::DrawBlueRedWhiteBigEnemyRight( int x, int y )
{
	gfx.PutPixel(2 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(15 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(15 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(15 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(15 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 12 + y, 222, 222, 222);

}
void Game::DrawBlueRedWhiteBigEnemyUp( int x, int y )
{
	gfx.PutPixel(4 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 15 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 15 + y, 222, 222, 222);

}
void Game::DrawBlueRedWhiteEnemyDown( int x, int y )
{
	gfx.PutPixel(7 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 11 + y, 255, 0, 0);

}
void Game::DrawBlueRedWhiteEnemyLeft( int x, int y )
{
	gfx.PutPixel(7 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 11 + y, 255, 0, 0);

}
void Game::DrawBlueRedWhiteEnemyRight( int x, int y )
{
	gfx.PutPixel(8 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 14 + y, 0, 104, 222);

}
void Game::DrawBlueRedWhiteEnemyUp( int x, int y )
{
	gfx.PutPixel(5 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 11 + y, 0, 104, 222);

}
void Game::DrawBlueYellowEnemyDown( int x, int y )
{
	gfx.PutPixel(5 + x, 0 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 1 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(8 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 4 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 4 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 4 + y, 0, 0, 222);
	gfx.PutPixel(9 + x, 4 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 5 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 5 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 5 + y, 0, 0, 222);
	gfx.PutPixel(10 + x, 5 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 6 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 6 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 7 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 7 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 7 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 222, 71, 0);
	gfx.PutPixel(8 + x, 7 + y, 222, 71, 0);
	gfx.PutPixel(9 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 8 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 8 + y, 222, 71, 0);
	gfx.PutPixel(5 + x, 8 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 8 + y, 222, 71, 0);
	gfx.PutPixel(7 + x, 8 + y, 222, 71, 0);
	gfx.PutPixel(10 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 9 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 9 + y, 222, 71, 0);
	gfx.PutPixel(5 + x, 9 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 9 + y, 222, 71, 0);
	gfx.PutPixel(10 + x, 9 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 10 + y, 222, 71, 0);

}
void Game::DrawBlueYellowEnemyLeft( int x, int y )
{
	gfx.PutPixel(1 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 1 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 1 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(7 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(8 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 4 + y, 222, 71, 0);
	gfx.PutPixel(2 + x, 4 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(0 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(1 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(2 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(2 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 7 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 7 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(8 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 8 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(7 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 9 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 9 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 10 + y, 0, 0, 222);

}
void Game::DrawBlueYellowEnemyRight( int x, int y )
{
	gfx.PutPixel(5 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(7 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(8 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(9 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 1 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 1 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(2 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(8 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 4 + y, 222, 71, 0);
	gfx.PutPixel(9 + x, 4 + y, 222, 71, 0);
	gfx.PutPixel(0 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(7 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(8 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(9 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(10 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(9 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(2 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 222, 71, 0);
	gfx.PutPixel(8 + x, 7 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 8 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 9 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 9 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(7 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(8 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(9 + x, 10 + y, 0, 0, 222);

}
void Game::DrawBlueYellowEnemyUp( int x, int y )
{
	gfx.PutPixel(5 + x, 0 + y, 222, 71, 0);
	gfx.PutPixel(0 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 1 + y, 222, 71, 0);
	gfx.PutPixel(5 + x, 1 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 1 + y, 222, 71, 0);
	gfx.PutPixel(10 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(5 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(7 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(10 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(8 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(9 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 4 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 4 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 4 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 5 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 5 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 5 + y, 0, 0, 222);
	gfx.PutPixel(10 + x, 5 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 6 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 6 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 6 + y, 0, 0, 222);
	gfx.PutPixel(9 + x, 6 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(8 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 10 + y, 255, 255, 0);

}
void Game::DrawBlueYellowRedEnemyDown( int x, int y )
{
	gfx.PutPixel(6 + x, 0 + y, 255, 184, 0);
	gfx.PutPixel(7 + x, 0 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 1 + y, 255, 184, 0);
	gfx.PutPixel(8 + x, 1 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 2 + y, 255, 184, 0);
	gfx.PutPixel(9 + x, 2 + y, 255, 184, 0);
	gfx.PutPixel(4 + x, 3 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 3 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 3 + y, 255, 184, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(2 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(7 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(8 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 7 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 7 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 7 + y, 255, 184, 0);
	gfx.PutPixel(8 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 8 + y, 255, 184, 0);
	gfx.PutPixel(8 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(0 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 10 + y, 255, 0, 0);

}
void Game::DrawBlueYellowRedEnemyLeft( int x, int y )
{
	gfx.PutPixel(1 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(0 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(7 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(2 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(8 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(9 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(0 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(4 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(10 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 7 + y, 255, 184, 0);
	gfx.PutPixel(1 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 8 + y, 255, 184, 0);
	gfx.PutPixel(2 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 9 + y, 255, 184, 0);
	gfx.PutPixel(1 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 10 + y, 0, 255, 222);

}
void Game::DrawBlueYellowRedEnemyRight( int x, int y )
{
	gfx.PutPixel(8 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 1 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 2 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(0 + x, 3 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(0 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(3 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(7 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(9 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(2 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(8 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(3 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(4 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(9 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 10 + y, 0, 255, 222);

}
void Game::DrawBlueYellowRedEnemyUp( int x, int y )
{
	gfx.PutPixel(4 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(0 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 2 + y, 255, 184, 0);
	gfx.PutPixel(8 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 3 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 3 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 3 + y, 255, 184, 0);
	gfx.PutPixel(8 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 4 + y, 255, 184, 0);
	gfx.PutPixel(8 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 184, 0);
	gfx.PutPixel(7 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 184, 0);
	gfx.PutPixel(4 + x, 7 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 7 + y, 255, 184, 0);
	gfx.PutPixel(6 + x, 7 + y, 255, 184, 0);
	gfx.PutPixel(1 + x, 8 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 8 + y, 255, 184, 0);
	gfx.PutPixel(2 + x, 9 + y, 255, 184, 0);
	gfx.PutPixel(5 + x, 9 + y, 255, 184, 0);
	gfx.PutPixel(3 + x, 10 + y, 255, 184, 0);
	gfx.PutPixel(4 + x, 10 + y, 255, 184, 0);

}
void Game::DrawEnemyBossHitOnceLookingDown( int x, int y )
{
	gfx.PutPixel(1 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(2 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(14 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(2 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(14 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 4 + y, 255, 0, 222);
	gfx.PutPixel(2 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 4 + y, 255, 0, 222);
	gfx.PutPixel(14 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 5 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 5 + y, 255, 0, 222);
	gfx.PutPixel(8 + x, 5 + y, 255, 0, 222);
	gfx.PutPixel(11 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 5 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 6 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 222);
	gfx.PutPixel(8 + x, 6 + y, 255, 0, 222);
	gfx.PutPixel(10 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 6 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(6 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(7 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(9 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(10 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(6 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(7 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(9 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(10 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 9 + y, 151, 0, 222);
	gfx.PutPixel(6 + x, 9 + y, 151, 0, 222);
	gfx.PutPixel(7 + x, 9 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 9 + y, 151, 0, 222);
	gfx.PutPixel(9 + x, 9 + y, 151, 0, 222);
	gfx.PutPixel(10 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 10 + y, 151, 0, 222);
	gfx.PutPixel(6 + x, 10 + y, 151, 0, 222);
	gfx.PutPixel(7 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 10 + y, 151, 0, 222);
	gfx.PutPixel(9 + x, 10 + y, 151, 0, 222);
	gfx.PutPixel(10 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(6 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(7 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(9 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(10 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 13 + y, 255, 0, 222);
	gfx.PutPixel(6 + x, 13 + y, 255, 0, 222);
	gfx.PutPixel(7 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 13 + y, 255, 0, 222);
	gfx.PutPixel(9 + x, 13 + y, 255, 0, 222);
	gfx.PutPixel(10 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 15 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 15 + y, 0, 104, 222);

}
void Game::DrawEnemyBossHitOnceLookingLeft( int x, int y )
{
	gfx.PutPixel(7 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 1 + y, 255, 0, 222);
	gfx.PutPixel(12 + x, 1 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 1 + y, 255, 0, 222);
	gfx.PutPixel(14 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(15 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(10 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(11 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(14 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(15 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 5 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 5 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 5 + y, 151, 0, 222);
	gfx.PutPixel(6 + x, 5 + y, 151, 0, 222);
	gfx.PutPixel(7 + x, 5 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 5 + y, 151, 0, 222);
	gfx.PutPixel(0 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 6 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 6 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 6 + y, 151, 0, 222);
	gfx.PutPixel(6 + x, 6 + y, 151, 0, 222);
	gfx.PutPixel(7 + x, 6 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 6 + y, 151, 0, 222);
	gfx.PutPixel(9 + x, 6 + y, 255, 0, 222);
	gfx.PutPixel(10 + x, 6 + y, 255, 0, 222);
	gfx.PutPixel(2 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(7 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(6 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(7 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(9 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(10 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(2 + x, 9 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 9 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 9 + y, 151, 0, 222);
	gfx.PutPixel(6 + x, 9 + y, 151, 0, 222);
	gfx.PutPixel(7 + x, 9 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 9 + y, 151, 0, 222);
	gfx.PutPixel(2 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(10 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(11 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(14 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(15 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 13 + y, 255, 0, 222);
	gfx.PutPixel(12 + x, 13 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 13 + y, 255, 0, 222);
	gfx.PutPixel(14 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(15 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 14 + y, 0, 104, 222);

}
void Game::DrawEnemyBossHitOnceLookingRight( int x, int y )
{
	gfx.PutPixel(1 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 1 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 1 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 1 + y, 255, 0, 222);
	gfx.PutPixel(5 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(6 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(7 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 5 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 5 + y, 151, 0, 222);
	gfx.PutPixel(9 + x, 5 + y, 151, 0, 222);
	gfx.PutPixel(10 + x, 5 + y, 151, 0, 222);
	gfx.PutPixel(11 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 5 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 5 + y, 255, 0, 222);
	gfx.PutPixel(5 + x, 6 + y, 255, 0, 222);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 222);
	gfx.PutPixel(7 + x, 6 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 6 + y, 151, 0, 222);
	gfx.PutPixel(9 + x, 6 + y, 151, 0, 222);
	gfx.PutPixel(10 + x, 6 + y, 151, 0, 222);
	gfx.PutPixel(11 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 6 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 6 + y, 255, 0, 222);
	gfx.PutPixel(14 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(15 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(9 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(10 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(6 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(7 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(9 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(10 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(11 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(14 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(15 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 9 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 9 + y, 151, 0, 222);
	gfx.PutPixel(9 + x, 9 + y, 151, 0, 222);
	gfx.PutPixel(10 + x, 9 + y, 151, 0, 222);
	gfx.PutPixel(11 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 9 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 9 + y, 255, 0, 222);
	gfx.PutPixel(6 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(6 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(7 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 13 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 13 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 13 + y, 255, 0, 222);
	gfx.PutPixel(5 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 14 + y, 0, 104, 222);

}
void Game::DrawEnemyBossHitOnceLookingUp( int x, int y )
{
	gfx.PutPixel(6 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(6 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(7 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(9 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(10 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(6 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(7 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(9 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(10 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 5 + y, 151, 0, 222);
	gfx.PutPixel(6 + x, 5 + y, 151, 0, 222);
	gfx.PutPixel(7 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 5 + y, 151, 0, 222);
	gfx.PutPixel(9 + x, 5 + y, 151, 0, 222);
	gfx.PutPixel(10 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 6 + y, 151, 0, 222);
	gfx.PutPixel(6 + x, 6 + y, 151, 0, 222);
	gfx.PutPixel(7 + x, 6 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 6 + y, 151, 0, 222);
	gfx.PutPixel(9 + x, 6 + y, 151, 0, 222);
	gfx.PutPixel(10 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(6 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(7 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(9 + x, 7 + y, 151, 0, 222);
	gfx.PutPixel(10 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(6 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(7 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(8 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(9 + x, 8 + y, 151, 0, 222);
	gfx.PutPixel(10 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 9 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 9 + y, 255, 0, 222);
	gfx.PutPixel(8 + x, 9 + y, 255, 0, 222);
	gfx.PutPixel(10 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 9 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 10 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 10 + y, 255, 0, 222);
	gfx.PutPixel(8 + x, 10 + y, 255, 0, 222);
	gfx.PutPixel(11 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 10 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 11 + y, 255, 0, 222);
	gfx.PutPixel(2 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 11 + y, 255, 0, 222);
	gfx.PutPixel(14 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(2 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 12 + y, 255, 0, 222);
	gfx.PutPixel(14 + x, 12 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 13 + y, 255, 0, 222);
	gfx.PutPixel(2 + x, 13 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 13 + y, 255, 0, 222);
	gfx.PutPixel(13 + x, 13 + y, 255, 0, 222);
	gfx.PutPixel(14 + x, 13 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 14 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 15 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 15 + y, 0, 104, 222);
	gfx.PutPixel(12 + x, 15 + y, 0, 104, 222);
	gfx.PutPixel(13 + x, 15 + y, 0, 104, 222);

}
void Game::DrawEnemyBossLookingDown( int x, int y )
{
	gfx.PutPixel(1 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(14 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(2 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(14 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(2 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(14 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 4 + y, 222, 71, 0);
	gfx.PutPixel(2 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 4 + y, 222, 71, 0);
	gfx.PutPixel(14 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 5 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 5 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 5 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(8 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(11 + x, 5 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 5 + y, 0, 151, 151);
	gfx.PutPixel(14 + x, 5 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(8 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(10 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(14 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 9 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 9 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 9 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 9 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 9 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 9 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 10 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 10 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 10 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 10 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(7 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(9 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(10 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 13 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 13 + y, 222, 71, 0);
	gfx.PutPixel(7 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 13 + y, 222, 71, 0);
	gfx.PutPixel(9 + x, 13 + y, 222, 71, 0);
	gfx.PutPixel(10 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 15 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 15 + y, 0, 151, 151);

}
void Game::DrawEnemyBossLookingLeft( int x, int y )
{
	gfx.PutPixel(7 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(10 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(14 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(10 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 1 + y, 222, 71, 0);
	gfx.PutPixel(12 + x, 1 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 1 + y, 222, 71, 0);
	gfx.PutPixel(14 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(15 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(10 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(11 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(14 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(15 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(10 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(14 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 5 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(0 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(10 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(2 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(0 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 8 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 8 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 8 + y, 222, 71, 0);
	gfx.PutPixel(10 + x, 8 + y, 222, 71, 0);
	gfx.PutPixel(2 + x, 9 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 9 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 9 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(10 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(14 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(10 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(11 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(14 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(15 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(10 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 13 + y, 222, 71, 0);
	gfx.PutPixel(12 + x, 13 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 13 + y, 222, 71, 0);
	gfx.PutPixel(14 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(15 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(10 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(14 + x, 14 + y, 0, 151, 151);

}
void Game::DrawEnemyBossLookingRight( int x, int y )
{
	gfx.PutPixel(1 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 1 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 1 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 1 + y, 222, 71, 0);
	gfx.PutPixel(5 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(7 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(10 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(11 + x, 5 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 5 + y, 222, 71, 0);
	gfx.PutPixel(5 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(11 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 6 + y, 222, 71, 0);
	gfx.PutPixel(14 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(15 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 8 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 8 + y, 222, 71, 0);
	gfx.PutPixel(7 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(11 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 8 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 8 + y, 222, 71, 0);
	gfx.PutPixel(14 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(15 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(11 + x, 9 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 9 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 9 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(10 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(7 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 13 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 13 + y, 222, 71, 0);
	gfx.PutPixel(4 + x, 13 + y, 222, 71, 0);
	gfx.PutPixel(5 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 14 + y, 0, 151, 151);

}
void Game::DrawEnemyBossLookingUp( int x, int y )
{
	gfx.PutPixel(6 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 0 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 1 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(7 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(9 + x, 2 + y, 222, 71, 0);
	gfx.PutPixel(10 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 2 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(6 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(7 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(9 + x, 3 + y, 222, 71, 0);
	gfx.PutPixel(10 + x, 3 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(7 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(9 + x, 4 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 5 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 5 + y, 0, 151, 151);
	gfx.PutPixel(8 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 5 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 6 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(14 + x, 7 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(5 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 8 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 9 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 9 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 9 + y, 0, 151, 151);
	gfx.PutPixel(4 + x, 9 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 9 + y, 222, 71, 0);
	gfx.PutPixel(8 + x, 9 + y, 222, 71, 0);
	gfx.PutPixel(10 + x, 9 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 9 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 9 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 9 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 10 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(6 + x, 10 + y, 222, 71, 0);
	gfx.PutPixel(8 + x, 10 + y, 222, 71, 0);
	gfx.PutPixel(11 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 10 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(14 + x, 10 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 11 + y, 222, 71, 0);
	gfx.PutPixel(2 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 11 + y, 222, 71, 0);
	gfx.PutPixel(14 + x, 11 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(2 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 12 + y, 222, 71, 0);
	gfx.PutPixel(14 + x, 12 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 13 + y, 222, 71, 0);
	gfx.PutPixel(2 + x, 13 + y, 222, 71, 0);
	gfx.PutPixel(3 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 13 + y, 222, 71, 0);
	gfx.PutPixel(13 + x, 13 + y, 222, 71, 0);
	gfx.PutPixel(14 + x, 13 + y, 0, 151, 151);
	gfx.PutPixel(0 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(3 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(11 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(14 + x, 14 + y, 0, 151, 151);
	gfx.PutPixel(1 + x, 15 + y, 0, 151, 151);
	gfx.PutPixel(2 + x, 15 + y, 0, 151, 151);
	gfx.PutPixel(12 + x, 15 + y, 0, 151, 151);
	gfx.PutPixel(13 + x, 15 + y, 0, 151, 151);

}
void Game::DrawEnemyDieStage1( int x, int y )
{
	gfx.PutPixel(5 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 7 + y, 222, 222, 222);

}
void Game::DrawEnemyDieStage2( int x, int y )
{
	gfx.PutPixel(7 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 10 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 10 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 10 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 10 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 10 + y, 255, 255, 0);
	gfx.PutPixel(11 + x, 10 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 11 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 11 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 12 + y, 222, 222, 222);

}
void Game::DrawEnemyDieStage3( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 1 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(13 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(12 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(11 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(15 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 10 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 11 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 12 + y, 255, 255, 0);
	gfx.PutPixel(11 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 12 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 13 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 13 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 13 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 14 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 14 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 14 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 14 + y, 255, 255, 0);
	gfx.PutPixel(15 + x, 14 + y, 255, 255, 0);
	gfx.PutPixel(0 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 15 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 15 + y, 222, 222, 222);

}
void Game::DrawEnemyDieStage4( int x, int y )
{
	gfx.PutPixel(7 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(11 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(16 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(11 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(11 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(19 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(22 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(12 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(14 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(17 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(16 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 10 + y, 255, 255, 0);
	gfx.PutPixel(19 + x, 10 + y, 255, 255, 0);
	gfx.PutPixel(22 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 11 + y, 255, 255, 0);
	gfx.PutPixel(24 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(17 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 13 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 14 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 14 + y, 255, 255, 0);
	gfx.PutPixel(23 + x, 14 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 18 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 18 + y, 255, 255, 0);
	gfx.PutPixel(21 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 19 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(17 + x, 19 + y, 255, 255, 0);
	gfx.PutPixel(22 + x, 19 + y, 255, 255, 0);
	gfx.PutPixel(23 + x, 19 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 20 + y, 255, 255, 0);
	gfx.PutPixel(11 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 20 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 21 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 21 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 21 + y, 255, 255, 0);
	gfx.PutPixel(20 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 22 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 23 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 24 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 25 + y, 255, 0, 0);
	gfx.PutPixel(17 + x, 27 + y, 222, 222, 222);

}
void Game::DrawEnemyDieStage5( int x, int y )
{
	gfx.PutPixel(15 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 1 + y, 255, 255, 0);
	gfx.PutPixel(21 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(29 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(13 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(27 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(30 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(23 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(21 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 13 + y, 255, 255, 0);
	gfx.PutPixel(30 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 15 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 15 + y, 255, 255, 0);
	gfx.PutPixel(23 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(27 + x, 16 + y, 255, 255, 0);
	gfx.PutPixel(28 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(27 + x, 17 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(29 + x, 21 + y, 255, 255, 0);
	gfx.PutPixel(0 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 24 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 26 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 26 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 27 + y, 255, 0, 0);
	gfx.PutPixel(28 + x, 27 + y, 255, 255, 0);
	gfx.PutPixel(1 + x, 28 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 28 + y, 255, 255, 0);
	gfx.PutPixel(29 + x, 28 + y, 255, 255, 0);
	gfx.PutPixel(17 + x, 29 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 30 + y, 255, 255, 0);
	gfx.PutPixel(26 + x, 30 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 31 + y, 255, 255, 0);

}
void Game::DrawEnemyMissileLookingDown( int x, int y )
{
	gfx.PutPixel(1 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 7 + y, 255, 0, 0);

}
void Game::DrawEnemyMissileLookingLeft( int x, int y )
{
	gfx.PutPixel(2 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 2 + y, 255, 0, 0);

}
void Game::DrawEnemyMissileLookingRight( int x, int y )
{
	gfx.PutPixel(4 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 2 + y, 255, 0, 0);

}
void Game::DrawEnemyMissileLookingUp( int x, int y )
{
	gfx.PutPixel(1 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 7 + y, 222, 222, 222);

}
void Game::DrawFighterDieStage1( int x, int y )
{
	gfx.PutPixel(18 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(21 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(20 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(23 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(20 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(21 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(21 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(20 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(23 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(25 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(23 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(26 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(18 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(24 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(18 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(24 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(28 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(16 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(18 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(24 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(25 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(28 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(16 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(18 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(21 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(25 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(16 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(17 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(18 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(21 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(27 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(16 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(17 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(18 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(21 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(26 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 17 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 17 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 17 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 17 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 17 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 17 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 17 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 17 + y, 255, 0, 0);
	gfx.PutPixel(16 + x, 17 + y, 255, 0, 0);
	gfx.PutPixel(17 + x, 17 + y, 255, 0, 0);
	gfx.PutPixel(18 + x, 17 + y, 255, 0, 0);
	gfx.PutPixel(19 + x, 17 + y, 255, 0, 0);
	gfx.PutPixel(21 + x, 17 + y, 255, 0, 0);
	gfx.PutPixel(24 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(25 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(0 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(16 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(17 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(18 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(19 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(20 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(21 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(26 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(16 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(17 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(19 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(20 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(21 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(24 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 20 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 20 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 20 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 20 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 20 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 20 + y, 255, 0, 0);
	gfx.PutPixel(16 + x, 20 + y, 255, 0, 0);
	gfx.PutPixel(17 + x, 20 + y, 255, 0, 0);
	gfx.PutPixel(20 + x, 20 + y, 255, 0, 0);
	gfx.PutPixel(21 + x, 20 + y, 255, 0, 0);
	gfx.PutPixel(24 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(27 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 21 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 21 + y, 255, 0, 0);
	gfx.PutPixel(21 + x, 21 + y, 255, 0, 0);
	gfx.PutPixel(23 + x, 21 + y, 255, 0, 0);
	gfx.PutPixel(25 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 22 + y, 255, 0, 0);
	gfx.PutPixel(26 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(25 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 24 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 24 + y, 255, 0, 0);
	gfx.PutPixel(17 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 24 + y, 255, 0, 0);
	gfx.PutPixel(21 + x, 24 + y, 255, 0, 0);
	gfx.PutPixel(24 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(21 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 26 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 26 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 27 + y, 222, 222, 222);

}
void Game::DrawFighterDieStage2( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(28 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(24 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(25 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(16 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(21 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(21 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(21 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(20 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(28 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(21 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(21 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(28 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(21 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 15 + y, 255, 0, 0);
	gfx.PutPixel(18 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(25 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(25 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 17 + y, 255, 0, 0);
	gfx.PutPixel(21 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(25 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(25 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 20 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 20 + y, 255, 0, 0);
	gfx.PutPixel(19 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(21 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 24 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 25 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(25 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(21 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(28 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 28 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 28 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 29 + y, 0, 255, 222);

}
void Game::DrawFighterDieStage3( int x, int y )
{
	gfx.PutPixel(11 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(21 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(31 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(21 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(25 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(30 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(21 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(28 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(29 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(30 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(29 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(16 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(17 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(27 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(24 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(27 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(28 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(29 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(23 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(27 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(28 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(29 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(30 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(27 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(29 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(30 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(28 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(30 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(31 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(29 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(30 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(28 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(30 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(31 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(27 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(28 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(30 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(31 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(27 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(29 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(30 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(31 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(28 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(29 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(30 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(18 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(25 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(27 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(28 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(29 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 17 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(28 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(29 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 19 + y, 255, 0, 0);
	gfx.PutPixel(26 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(29 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(30 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(29 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(31 + x, 20 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(29 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(30 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(31 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 23 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(28 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 24 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 24 + y, 255, 0, 0);
	gfx.PutPixel(22 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(28 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 25 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(6 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(27 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(28 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 26 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 26 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 26 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 26 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 26 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 26 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 26 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(25 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 27 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(21 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(25 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(29 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(30 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 28 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 28 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 28 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 28 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 28 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 28 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 28 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 28 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 28 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 28 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 28 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 28 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 28 + y, 0, 255, 222);
	gfx.PutPixel(28 + x, 28 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 29 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 29 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 29 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 29 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 29 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 29 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 29 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 29 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 29 + y, 0, 255, 222);
	gfx.PutPixel(21 + x, 29 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 29 + y, 255, 0, 0);
	gfx.PutPixel(29 + x, 29 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 30 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 30 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 30 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 30 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 30 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 30 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 30 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 30 + y, 0, 255, 222);
	gfx.PutPixel(21 + x, 30 + y, 0, 255, 222);
	gfx.PutPixel(30 + x, 30 + y, 0, 255, 222);
	gfx.PutPixel(0 + x, 31 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 31 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 31 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 31 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 31 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 31 + y, 0, 255, 222);
	gfx.PutPixel(31 + x, 31 + y, 0, 255, 222);

}
void Game::DrawFighterDieStage4( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 0 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(28 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 1 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 2 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(25 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 3 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 4 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(16 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 5 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 6 + y, 0, 255, 222);
	gfx.PutPixel(19 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(20 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(22 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 7 + y, 0, 255, 222);
	gfx.PutPixel(0 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(4 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(20 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 8 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(27 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(28 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(20 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 9 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 10 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(27 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(28 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 11 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(26 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(19 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 12 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 13 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 14 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 15 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 16 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 16 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 16 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 17 + y, 222, 222, 222);
	gfx.PutPixel(25 + x, 17 + y, 0, 255, 222);
	gfx.PutPixel(3 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(21 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 18 + y, 0, 255, 222);
	gfx.PutPixel(25 + x, 18 + y, 222, 222, 222);
	gfx.PutPixel(27 + x, 18 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 19 + y, 0, 255, 222);
	gfx.PutPixel(5 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 19 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(14 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 20 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 20 + y, 0, 255, 222);
	gfx.PutPixel(7 + x, 21 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 21 + y, 255, 0, 0);
	gfx.PutPixel(15 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(21 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(22 + x, 21 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(8 + x, 22 + y, 0, 255, 222);
	gfx.PutPixel(10 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(23 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(24 + x, 22 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(9 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(15 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(17 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 23 + y, 0, 255, 222);
	gfx.PutPixel(23 + x, 23 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(11 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(12 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(13 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(16 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(17 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(18 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 24 + y, 0, 255, 222);
	gfx.PutPixel(24 + x, 24 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(18 + x, 25 + y, 222, 222, 222);
	gfx.PutPixel(19 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(25 + x, 25 + y, 0, 255, 222);
	gfx.PutPixel(2 + x, 26 + y, 255, 0, 0);
	gfx.PutPixel(21 + x, 26 + y, 0, 255, 222);
	gfx.PutPixel(26 + x, 26 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 27 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(20 + x, 27 + y, 0, 255, 222);
	gfx.PutPixel(27 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(28 + x, 27 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 28 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 28 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 29 + y, 222, 222, 222);

}
void Game::DrawFighterLookingDown( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 15 + y, 222, 222, 222);

}
void Game::DrawFighterLookingLeft( int x, int y )
{
	gfx.PutPixel(8 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(14 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 14 + y, 222, 222, 222);

}
void Game::DrawFighterLookingRight( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(15 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 10 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 11 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 14 + y, 255, 0, 0);

}
void Game::DrawFighterLookingUp( int x, int y )
{
	gfx.PutPixel(7 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(11 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(14 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(11 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(12 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 13 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(13 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 13 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(9 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 14 + y, 255, 0, 0);
	gfx.PutPixel(13 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 14 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 15 + y, 222, 222, 222);
	gfx.PutPixel(14 + x, 15 + y, 222, 222, 222);

}
void Game::DrawFighterMissileLookingDown( int x, int y )
{
	gfx.PutPixel(1 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 104, 222);

}
void Game::DrawFighterMissileLookingLeft( int x, int y )
{
	gfx.PutPixel(2 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(3 + x, 2 + y, 0, 104, 222);

}
void Game::DrawFighterMissileLookingRight( int x, int y )
{
	gfx.PutPixel(4 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 1 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 2 + y, 0, 104, 222);

}
void Game::DrawFighterMissileLookingUp( int x, int y )
{
	gfx.PutPixel(1 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 2 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 7 + y, 255, 0, 0);

}
void Game::DrawGreenPurpleEnemyDown( int x, int y )
{
	gfx.PutPixel(5 + x, 0 + y, 0, 255, 0);
	gfx.PutPixel(0 + x, 1 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 1 + y, 0, 255, 0);
	gfx.PutPixel(10 + x, 1 + y, 0, 255, 0);
	gfx.PutPixel(0 + x, 2 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 2 + y, 0, 255, 0);
	gfx.PutPixel(10 + x, 2 + y, 0, 255, 0);
	gfx.PutPixel(0 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(1 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(9 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(10 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(0 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(1 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(2 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(3 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(9 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(10 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(1 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(2 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(3 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(9 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(1 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(2 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(3 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(9 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(2 + x, 7 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 7 + y, 255, 0, 222);
	gfx.PutPixel(2 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(8 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 9 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 9 + y, 255, 0, 222);
	gfx.PutPixel(5 + x, 9 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 9 + y, 255, 0, 222);
	gfx.PutPixel(7 + x, 9 + y, 255, 0, 222);
	gfx.PutPixel(5 + x, 10 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 11 + y, 0, 255, 0);

}
void Game::DrawGreenPurpleEnemyLeft( int x, int y )
{
	gfx.PutPixel(7 + x, 0 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 0 + y, 0, 255, 0);
	gfx.PutPixel(9 + x, 0 + y, 0, 255, 0);
	gfx.PutPixel(10 + x, 0 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 1 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 1 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 1 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 1 + y, 0, 255, 0);
	gfx.PutPixel(3 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(5 + x, 2 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 2 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 2 + y, 0, 255, 0);
	gfx.PutPixel(2 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(2 + x, 4 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(0 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(1 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(2 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(3 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(9 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(10 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(11 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(2 + x, 6 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(2 + x, 7 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 7 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(3 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(5 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 9 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 9 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 9 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 9 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 10 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 10 + y, 0, 255, 0);
	gfx.PutPixel(9 + x, 10 + y, 0, 255, 0);
	gfx.PutPixel(10 + x, 10 + y, 0, 255, 0);

}
void Game::DrawGreenPurpleEnemyRight( int x, int y )
{
	gfx.PutPixel(1 + x, 0 + y, 0, 255, 0);
	gfx.PutPixel(2 + x, 0 + y, 0, 255, 0);
	gfx.PutPixel(3 + x, 0 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 0 + y, 0, 255, 0);
	gfx.PutPixel(3 + x, 1 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 1 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 1 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 1 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 2 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 2 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 2 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(8 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(9 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(9 + x, 4 + y, 255, 0, 222);
	gfx.PutPixel(0 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(1 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(2 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(3 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(9 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(10 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(11 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(3 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(9 + x, 6 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 7 + y, 255, 0, 222);
	gfx.PutPixel(9 + x, 7 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(8 + x, 8 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 9 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 9 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 9 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 9 + y, 0, 255, 0);
	gfx.PutPixel(1 + x, 10 + y, 0, 255, 0);
	gfx.PutPixel(2 + x, 10 + y, 0, 255, 0);
	gfx.PutPixel(3 + x, 10 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 10 + y, 0, 255, 0);

}
void Game::DrawGreenPurpleEnemyUp( int x, int y )
{
	gfx.PutPixel(5 + x, 0 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 1 + y, 0, 255, 0);
	gfx.PutPixel(3 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(5 + x, 2 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(7 + x, 2 + y, 255, 0, 222);
	gfx.PutPixel(2 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(4 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 3 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(8 + x, 3 + y, 255, 0, 222);
	gfx.PutPixel(2 + x, 4 + y, 255, 0, 222);
	gfx.PutPixel(3 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 4 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 4 + y, 255, 0, 222);
	gfx.PutPixel(1 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(2 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(3 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(9 + x, 5 + y, 0, 255, 0);
	gfx.PutPixel(1 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(2 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(3 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(9 + x, 6 + y, 0, 255, 0);
	gfx.PutPixel(0 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(1 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(2 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(3 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(8 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(9 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(10 + x, 7 + y, 0, 255, 0);
	gfx.PutPixel(0 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(1 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(4 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(6 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(9 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(10 + x, 8 + y, 0, 255, 0);
	gfx.PutPixel(0 + x, 9 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 9 + y, 0, 255, 0);
	gfx.PutPixel(10 + x, 9 + y, 0, 255, 0);
	gfx.PutPixel(0 + x, 10 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 10 + y, 0, 255, 0);
	gfx.PutPixel(10 + x, 10 + y, 0, 255, 0);
	gfx.PutPixel(5 + x, 11 + y, 0, 255, 0);

}
void Game::DrawRedEnemyLookingDown( int x, int y )
{
	gfx.PutPixel(3 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 9 + y, 255, 0, 0);

}
void Game::DrawRedEnemyLookingLeft( int x, int y )
{
	gfx.PutPixel(1 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 12 + y, 255, 0, 0);

}
void Game::DrawRedEnemyLookingRight( int x, int y )
{
	gfx.PutPixel(2 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 7 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 10 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 11 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 12 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 12 + y, 255, 0, 0);

}
void Game::DrawRedEnemyLookingUp( int x, int y )
{
	gfx.PutPixel(2 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(10 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(10 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(12 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(10 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(11 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 9 + y, 255, 0, 0);

}
void Game::DrawRedEnemyWingsClosedLookingDown( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 0 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 9 + y, 255, 0, 0);

}
void Game::DrawRedEnemyWingsClosedLookingLeft( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(9 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 8 + y, 255, 0, 0);

}
void Game::DrawRedEnemyWingsClosedLookingRight( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 3 + y, 0, 104, 222);
	gfx.PutPixel(0 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(1 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 4 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(2 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(7 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(9 + x, 8 + y, 255, 0, 0);

}
void Game::DrawRedEnemyWingsClosedLookingUp( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 0 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 1 + y, 0, 104, 222);
	gfx.PutPixel(8 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(8 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 5 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 6 + y, 0, 104, 222);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(7 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(5 + x, 8 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 8 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 9 + y, 0, 104, 222);
	gfx.PutPixel(7 + x, 9 + y, 255, 0, 0);
	gfx.PutPixel(8 + x, 9 + y, 255, 0, 0);

}
void Game::DrawStage( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 7 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 9 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 11 + y, 222, 222, 222);

}
void Game::DrawStage5( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 0 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 1 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 2 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 2 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 3 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 3 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 4 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 4 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 5 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 5 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 6 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 6 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(1 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(2 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(3 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(4 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(5 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(6 + x, 7 + y, 255, 0, 0);
	gfx.PutPixel(0 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 8 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(6 + x, 9 + y, 222, 222, 222);
	gfx.PutPixel(0 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(5 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 10 + y, 222, 222, 222);
	gfx.PutPixel(1 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 11 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(4 + x, 11 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 11 + y, 222, 222, 222);
	gfx.PutPixel(2 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 12 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 12 + y, 222, 222, 222);
	gfx.PutPixel(3 + x, 13 + y, 222, 222, 222);

}
void Game::DrawStage10( int x, int y )
{
	gfx.PutPixel(0 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(7 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(8 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(9 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(10 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(11 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(12 + x, 0 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 1 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(8 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(9 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(10 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(11 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(12 + x, 1 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 2 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(9 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(10 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(11 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(12 + x, 2 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(2 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(8 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(9 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(11 + x, 3 + y, 255, 255, 0);
	gfx.PutPixel(12 + x, 3 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 4 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 4 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 4 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 4 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 4 + y, 0, 0, 222);
	gfx.PutPixel(8 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 4 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 4 + y, 0, 0, 222);
	gfx.PutPixel(11 + x, 4 + y, 0, 0, 222);
	gfx.PutPixel(12 + x, 4 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 5 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 5 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(3 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 5 + y, 255, 255, 0);
	gfx.PutPixel(11 + x, 5 + y, 0, 0, 222);
	gfx.PutPixel(12 + x, 5 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 6 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 6 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 6 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 6 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(6 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(8 + x, 6 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 6 + y, 0, 0, 222);
	gfx.PutPixel(10 + x, 6 + y, 0, 0, 222);
	gfx.PutPixel(11 + x, 6 + y, 0, 0, 222);
	gfx.PutPixel(12 + x, 6 + y, 0, 0, 222);
	gfx.PutPixel(0 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(4 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(8 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 7 + y, 255, 255, 0);
	gfx.PutPixel(10 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(11 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(12 + x, 7 + y, 0, 0, 222);
	gfx.PutPixel(1 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(8 + x, 8 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(10 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(11 + x, 8 + y, 0, 0, 222);
	gfx.PutPixel(2 + x, 9 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 9 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(5 + x, 9 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 9 + y, 0, 0, 222);
	gfx.PutPixel(8 + x, 9 + y, 255, 255, 0);
	gfx.PutPixel(9 + x, 9 + y, 0, 0, 222);
	gfx.PutPixel(10 + x, 9 + y, 0, 0, 222);
	gfx.PutPixel(3 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 10 + y, 255, 255, 0);
	gfx.PutPixel(7 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(8 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(9 + x, 10 + y, 0, 0, 222);
	gfx.PutPixel(4 + x, 11 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 11 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 11 + y, 0, 0, 222);
	gfx.PutPixel(7 + x, 11 + y, 0, 0, 222);
	gfx.PutPixel(8 + x, 11 + y, 0, 0, 222);
	gfx.PutPixel(5 + x, 12 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 12 + y, 0, 0, 222);
	gfx.PutPixel(7 + x, 12 + y, 0, 0, 222);
	gfx.PutPixel(6 + x, 13 + y, 0, 0, 222);

}


void Game::UpdateGame()
{
	if( kbd.RightIsPressed() )
	{
		DrawFighterLookingRight( int x, int y );
		FighterLookingRight.x++;
	}

	if( kbd.LeftIsPressed() )
	{
		DrawFighterLookingLeft( int x, int y );
		FighterLookingUp.x--;
	}

	if( kbd.UpIsPressed() )
	{
		DrawFighterLookingUp( int x, int y );
		FighterLookingUp.y++;
	}

	if( kbd.DownIsPressed() )
	{
		DrawFighterLookingDown( int x, int y );
		FighterLookingDown.y++;
	}
}



void Game::Border()
{
	//Barrier/Border
	if( FighterLookingUp.x < 0 )
	{
		FighterLookingUp.x = 0;
	}

	if( FighterLookingUp.x + 15 > 799)
	{
		FighterLookingUp.x = 799 - 15;
	}
	if( FighterLookingUp.y < 0 )
	{
		FighterLookingUp.y = 0;
	}

	if( FighterLookingUp.y + 16 > 599)
	{
		FighterLookingUp.y = 599 - 16;
	}




	if( FighterLookingLeft.x < 0 )
	{
		FighterLookingLeft.x = 0;
	}

	if( FighterLookingLeft.x + 16 > 799)
	{
		FighterLookingLeft.x = 799 - 16;
	}
	if( FighterLookingLeft.y < 0 )
	{
		FighterLookingLeft.y = 0;
	}

	if( FighterLookingLeft.y + 15 > 599)
	{
		FighterLookingLeft.y = 599 - 15;
	}




	if( FighterLookingDown.x < 0 )
	{
		FighterLookingDown.x = 0;
	}

	if( FighterLookingDown.x + 15 > 799)
	{
		FighterLookingDown.x = 799 - 15;
	}
	if( FighterLookingDown.y < 0 )
	{
		FighterLookingDown.y = 0;
	}

	if( FighterLookingDown.y + 16 > 599)
	{
		FighterLookingDown.y = 599 - 16;
	}




	if( FighterLookingRight.x < 0 )
	{
		FighterLookingRight.x = 0;
	}

	if( FighterLookingRight.x + 16 > 799)
	{
		FighterLookingRight.x = 799 - 16;
	}
	if( FighterLookingRight.y < 0 )
	{
		FighterLookingRight.y = 0;
	}

	if( FighterLookingRight.y + 15 > 599)
	{
		FighterLookingRight.y = 599 - 15;
	}

}
void Game::ComposeFrame()
{
	
	DrawFighterLookingUp( 390, 250 );
}